blob: b43668d0e8bddc6b8b703b3f2e14a59a862a3b0d [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
40 tmp_dir="${TMPDIR}/$USER/${test_dir}"
41fi
jeffhao5d1ac922011-09-29 17:41:15 -070042
43export JAVA="java"
Brian Carlstrom5103ce62014-03-30 16:17:42 -070044export JAVAC="javac -g"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
jeffhao5d1ac922011-09-29 17:41:15 -070048
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070049# If dx was not set by the environment variable, assume it is in the path.
50if [ -z "$DX" ]; then
51 export DX="dx"
52fi
53
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080054# If jasmin was not set by the environment variable, assume it is in the path.
55if [ -z "$JASMIN" ]; then
56 export JASMIN="jasmin"
57fi
58
Andreas Gampe8fda9f22014-10-03 16:15:37 -070059# If smali was not set by the environment variable, assume it is in the path.
60if [ -z "$SMALI" ]; then
61 export SMALI="smali"
62fi
63
64# If dexmerger was not set by the environment variable, assume it is in the path.
65if [ -z "$DXMERGER" ]; then
66 export DXMERGER="dexmerger"
67fi
68
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080069
jeffhao5d1ac922011-09-29 17:41:15 -070070info="info.txt"
71build="build"
72run="run"
73expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -070074check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -070075output="output.txt"
76build_output="build-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -070077lib="libartd.so"
jeffhao5d1ac922011-09-29 17:41:15 -070078run_args="--quiet"
79
Alex Light9d722532014-07-22 18:07:12 -070080prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -070081target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -070082dev_mode="no"
83update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -070084debug_mode="no"
85relocate="yes"
Jeff Hao201803f2013-11-20 18:11:39 -080086runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -070087usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -070088build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -070089suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -070090trace="false"
Alex Lighte7873ec2014-08-12 09:53:50 -070091basic_verify="false"
92gc_verify="false"
93gc_stress="false"
Alex Lightbfac14a2014-07-30 09:41:21 -070094always_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -070095have_dex2oat="yes"
96have_patchoat="yes"
97have_image="yes"
Andreas Gampe63fc30e2014-10-24 21:58:16 -070098image_suffix=""
Andreas Gampec23c9c92014-10-28 14:47:25 -070099pic_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000100android_root="/system"
jeffhao5d1ac922011-09-29 17:41:15 -0700101
102while true; do
103 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700104 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700105 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100106 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700107 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800108 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700109 target_mode="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800110 runtime="jvm"
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700111 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700112 NEED_DEX="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100113 run_args="${run_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700114 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800115 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700116 lib="libart.so"
117 shift
118 elif [ "x$1" = "x--dalvik" ]; then
119 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800120 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700121 shift
Alex Light03a112d2014-08-25 13:25:56 -0700122 elif [ "x$1" = "x--no-dex2oat" ]; then
123 have_dex2oat="no"
124 shift
125 elif [ "x$1" = "x--no-patchoat" ]; then
126 have_patchoat="no"
127 shift
128 elif [ "x$1" = "x--no-image" ]; then
129 have_image="no"
130 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700131 elif [ "x$1" = "x--pic-image" ]; then
132 pic_image_suffix="-pic"
133 shift
134 elif [ "x$1" = "x--pic-test" ]; then
135 run_args="${run_args} --pic-test"
136 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700137 elif [ "x$1" = "x--relocate" ]; then
138 relocate="yes"
139 shift
140 elif [ "x$1" = "x--no-relocate" ]; then
141 relocate="no"
142 shift
143 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100144 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700145 prebuild_mode="yes"
146 shift;
147 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100148 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700149 prebuild_mode="no"
150 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700151 elif [ "x$1" = "x--gcverify" ]; then
152 basic_verify="true"
153 gc_verify="true"
154 shift
155 elif [ "x$1" = "x--gcstress" ]; then
156 basic_verify="true"
157 gc_stress="true"
158 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700159 elif [ "x$1" = "x--image" ]; then
160 shift
161 image="$1"
162 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700163 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000164 elif [ "x$1" = "x-Xcompiler-option" ]; then
165 shift
166 option="$1"
167 run_args="${run_args} -Xcompiler-option $option"
168 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700169 elif [ "x$1" = "x--runtime-option" ]; then
170 shift
171 option="$1"
172 run_args="${run_args} --runtime-option $option"
173 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700174 elif [ "x$1" = "x--debug" ]; then
175 run_args="${run_args} --debug"
176 shift
177 elif [ "x$1" = "x--gdb" ]; then
178 run_args="${run_args} --gdb"
179 dev_mode="yes"
180 shift
181 elif [ "x$1" = "x--zygote" ]; then
182 run_args="${run_args} --zygote"
183 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800184 elif [ "x$1" = "x--interpreter" ]; then
185 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700186 image_suffix="-interpreter"
187 shift
188 elif [ "x$1" = "x--optimizing" ]; then
189 run_args="${run_args} -Xcompiler-option --compiler-backend=Optimizing"
190 image_suffix="-optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800191 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700192 elif [ "x$1" = "x--no-verify" ]; then
193 run_args="${run_args} --no-verify"
194 shift
195 elif [ "x$1" = "x--no-optimize" ]; then
196 run_args="${run_args} --no-optimize"
197 shift
198 elif [ "x$1" = "x--no-precise" ]; then
199 run_args="${run_args} --no-precise"
200 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700201 elif [ "x$1" = "x--invoke-with" ]; then
202 shift
203 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700204 if [ "x$what" = "x" ]; then
205 echo "$0 missing argument to --invoke-with" 1>&2
206 usage="yes"
207 break
208 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700209 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700210 shift
211 elif [ "x$1" = "x--dev" ]; then
212 run_args="${run_args} --dev"
213 dev_mode="yes"
214 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700215 elif [ "x$1" = "x--build-only" ]; then
216 build_only="yes"
217 shift
218 elif [ "x$1" = "x--output-path" ]; then
219 shift
220 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700221 if [ "x$tmp_dir" = "x" ]; then
222 echo "$0 missing argument to --output-path" 1>&2
223 usage="yes"
224 break
225 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700226 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000227 elif [ "x$1" = "x--android-root" ]; then
228 shift
229 if [ "x$1" = "x" ]; then
230 echo "$0 missing argument to --android-root" 1>&2
231 usage="yes"
232 break
233 fi
234 android_root="$1"
235 run_args="${run_args} --android-root $1"
236 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700237 elif [ "x$1" = "x--update" ]; then
238 update_mode="yes"
239 shift
240 elif [ "x$1" = "x--help" ]; then
241 usage="yes"
242 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700243 elif [ "x$1" = "x--64" ]; then
244 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700245 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700246 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200247 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700248 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200249 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700250 elif [ "x$1" = "x--always-clean" ]; then
251 always_clean="yes"
252 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700253 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700254 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700255 usage="yes"
256 break
257 else
258 break
259 fi
260done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700261
262# tmp_dir may be relative, resolve.
263#
264# Cannot use realpath, as it does not exist on Mac.
265# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700266# Cannot use readlink -m, as it does not exist on Mac.
267# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700268noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700269tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700270mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700271
Alex Lighte7873ec2014-08-12 09:53:50 -0700272if [ "$basic_verify" = "true" ]; then
273 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify"
274fi
275if [ "$gc_verify" = "true" ]; then
276 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
277fi
278if [ "$gc_stress" = "true" ]; then
279 run_args="${run_args} --runtime-option -Xgc:SS --runtime-option -Xms2m --runtime-option -Xmx2m"
280fi
Jeff Hao85139a32014-07-23 11:52:52 -0700281if [ "$trace" = "true" ]; then
282 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin --runtime-option -Xmethod-trace-file-size:2000000"
283fi
284
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700285# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100286# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700287function guess_arch_name() {
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100288 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
289 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700290 if [ "x${suffix64}" = "x64" ]; then
291 target_arch_name=${grep64bit}
292 else
293 target_arch_name=${grep32bit}
294 fi
295}
296
Alex Lighta59dd802014-07-02 16:28:08 -0700297if [ "$target_mode" = "no" ]; then
298 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700299 if [ "$prebuild_mode" = "yes" ]; then
300 echo "--prebuild with --jvm is unsupported";
301 exit 1;
302 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700303 fi
304fi
305
Alex Light03a112d2014-08-25 13:25:56 -0700306if [ "$have_patchoat" = "no" ]; then
307 run_args="${run_args} --no-patchoat"
308fi
309
310if [ "$have_dex2oat" = "no" ]; then
311 run_args="${run_args} --no-dex2oat"
312fi
313
Jeff Hao201803f2013-11-20 18:11:39 -0800314if [ ! "$runtime" = "jvm" ]; then
315 run_args="${run_args} --lib $lib"
316fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700317
Jeff Hao201803f2013-11-20 18:11:39 -0800318if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700319 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100320 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700321 bpath="${framework}/core.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/core-junit.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
322 run_args="${run_args} --boot -Xbootclasspath:${bpath}"
323 else
324 true # defaults to using target BOOTCLASSPATH
325 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800326elif [ "$runtime" = "art" ]; then
327 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100328 # ANDROID_BUILD_TOP and ANDROID_HOST_OUT are not set in a build environment.
Brian Carlstrom43534862014-02-19 01:13:52 -0800329 if [ -z "$ANDROID_BUILD_TOP" ]; then
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100330 export ANDROID_BUILD_TOP=$oldwd
Brian Carlstrom43534862014-02-19 01:13:52 -0800331 fi
332 if [ -z "$ANDROID_HOST_OUT" ]; then
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100333 export ANDROID_HOST_OUT=$ANDROID_BUILD_TOP/out/host/linux-x86
Brian Carlstrom43534862014-02-19 01:13:52 -0800334 fi
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000335 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}.art"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700336 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800337 else
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700338 guess_arch_name
339 run_args="${run_args} --runtime-option -Djava.library.path=/data/art-test/${target_arch_name}"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000340 run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800341 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700342 if [ "$relocate" = "yes" ]; then
343 run_args="${run_args} --relocate"
344 else
345 run_args="${run_args} --no-relocate"
346 fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700347fi
348
Alex Light03a112d2014-08-25 13:25:56 -0700349if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700350 if [ "$runtime" != "art" ]; then
351 echo "--no-image is only supported on the art runtime"
352 exit 1
353 fi
354 if [ "$target_mode" = "no" ]; then
355 framework="${ANDROID_HOST_OUT}/framework"
356 bpath_suffix="-hostdex"
357 else
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000358 framework="${android_root}/framework"
Alex Light1ef4ce82014-08-27 11:13:47 -0700359 bpath_suffix=""
360 fi
361 # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will
362 # fail since these jar files will be stripped.
363 bpath="${framework}/core-libart${bpath_suffix}.jar"
364 bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar"
365 bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar"
366 bpath="${bpath}:${framework}/core-junit${bpath_suffix}.jar"
367 bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar"
368 # Pass down the bootclasspath
369 run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}"
Alex Light03a112d2014-08-25 13:25:56 -0700370 run_args="${run_args} --no-image"
371fi
372
jeffhao5d1ac922011-09-29 17:41:15 -0700373if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
374 echo "--dev and --update are mutually exclusive" 1>&2
375 usage="yes"
376fi
377
378if [ "$usage" = "no" ]; then
379 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
380 test_dir=`basename "$oldwd"`
381 else
382 test_dir="$1"
383 fi
384
385 if [ '!' -d "$test_dir" ]; then
386 td2=`echo ${test_dir}-*`
387 if [ '!' -d "$td2" ]; then
388 echo "${test_dir}: no such test directory" 1>&2
389 usage="yes"
390 fi
391 test_dir="$td2"
392 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700393 # Shift to get rid of the test name argument. The rest of the arguments
394 # will get passed to the test run.
395 shift
396fi
397
398if [ "$usage" = "yes" ]; then
399 prog=`basename $prog`
400 (
401 echo "usage:"
402 echo " $prog --help Print this message."
403 echo " $prog [options] [test-name] Run test normally."
404 echo " $prog --dev [options] [test-name] Development mode" \
405 "(dumps to stdout)."
406 echo " $prog --update [options] [test-name] Update mode" \
407 "(replaces expected.txt)."
408 echo ' Omitting the test name or specifying "-" will use the' \
409 "current directory."
410 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000411 echo " -O Run non-debug rather than debug build (off by default)."
412 echo " -Xcompiler-option Pass an option to the compiler."
413 echo " --runtime-option Pass an option to the runtime."
414 echo " --debug Wait for a debugger to attach."
415 echo " --gdb Run under gdb; incompatible with some tests."
416 echo " --build-only Build test files only (off by default)."
417 echo " --interpreter Enable interpreter only mode (off by default)."
418 echo " --optimizing Enable optimizing compiler (off by default)."
419 echo " --no-verify Turn off verification (on by default)."
420 echo " --no-optimize Turn off optimization (on by default)."
421 echo " --no-precise Turn off precise GC (on by default)."
422 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700423 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000424 echo " other runtime options are ignored."
425 echo " --no-dex2oat Run as though dex2oat was failing."
426 echo " --no-patchoat Run as though patchoat was failing."
427 echo " --prebuild Run dex2oat on the files before starting test. (default)"
428 echo " --no-prebuild Do not run dex2oat on the files before starting"
429 echo " the test."
430 echo " --relocate Force the use of relocating in the test, making"
431 echo " the image and oat files be relocated to a random"
432 echo " address before running. (default)"
433 echo " --no-relocate Force the use of no relocating in the test"
434 echo " --host Use the host-mode virtual machine."
435 echo " --invoke-with Pass --invoke-with option to runtime."
436 echo " --dalvik Use Dalvik (off by default)."
437 echo " --jvm Use a host-local RI virtual machine."
438 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700439 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000440 echo " --64 Run the test in 64-bit mode"
441 echo " --trace Run with method tracing"
442 echo " --gcstress Run with gc stress testing"
443 echo " --gcverify Run with gc verification"
444 echo " --always-clean Delete the test files even if the test fails."
445 echo " --android-root [path] The path on target for the android root. (/system by default)."
jeffhao5d1ac922011-09-29 17:41:15 -0700446 ) 1>&2
447 exit 1
448fi
449
450cd "$test_dir"
451test_dir=`pwd`
452
453td_info="${test_dir}/${info}"
454td_expected="${test_dir}/${expected}"
455
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700456if [ ! -r $td_info ]; then
457 echo "${test_dir}: missing file $td_info" 1>&2
458 exit 1
459fi
460
461if [ ! -r $td_expected ]; then
462 echo "${test_dir}: missing file $td_expected" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700463 exit 1
464fi
465
466# copy the test to a temp dir and run it
467
Elliott Hughes510c8782011-10-06 10:57:34 -0700468echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700469
470rm -rf "$tmp_dir"
471cp -Rp "$test_dir" "$tmp_dir"
472cd "$tmp_dir"
473
474if [ '!' -r "$build" ]; then
475 cp "${progdir}/etc/default-build" build
476fi
477
478if [ '!' -r "$run" ]; then
479 cp "${progdir}/etc/default-run" run
480fi
481
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700482if [ '!' -r "$check_cmd" ]; then
483 cp "${progdir}/etc/default-check" check
484fi
485
jeffhao5d1ac922011-09-29 17:41:15 -0700486chmod 755 "$build"
487chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700488chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700489
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700490export TEST_NAME=`basename ${test_dir}`
491
Ian Rogers997f0f92014-06-21 22:58:05 -0700492# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB.
493file_size_limit=2048
494if echo "$test_dir" | grep 089; then
495 file_size_limit=5120
496elif echo "$test_dir" | grep 083; then
497 file_size_limit=5120
498fi
Alex Lighta59dd802014-07-02 16:28:08 -0700499if ! ulimit -S "$file_size_limit"; then
Ian Rogers997f0f92014-06-21 22:58:05 -0700500 echo "ulimit file size setting failed"
501fi
502
jeffhao5d1ac922011-09-29 17:41:15 -0700503good="no"
504if [ "$dev_mode" = "yes" ]; then
505 "./${build}" 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700506 build_exit="$?"
507 echo "build exit status: $build_exit" 1>&2
508 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800509 echo "${test_dir}: running..." 1>&2
510 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700511 run_exit="$?"
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800512 echo "run exit status: $run_exit" 1>&2
513 if [ "$run_exit" = "0" ]; then
514 good="yes"
515 fi
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700516 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700517elif [ "$update_mode" = "yes" ]; then
518 "./${build}" >"$build_output" 2>&1
519 build_exit="$?"
520 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800521 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700522 "./${run}" $run_args "$@" >"$output" 2>&1
523 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
524 good="yes"
525 else
526 cat "$build_output" 1>&2
527 echo "build exit status: $build_exit" 1>&2
528 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700529elif [ "$build_only" = "yes" ]; then
530 good="yes"
531 "./${build}" >"$build_output" 2>&1
532 build_exit="$?"
533 if [ "$build_exit" '!=' '0' ]; then
534 cp "$build_output" "$output"
535 echo "build exit status: $build_exit" >>"$output"
536 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
537 if [ "$?" '!=' "0" ]; then
538 good="no"
539 echo "BUILD FAILED For ${TEST_NAME}"
540 fi
541 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700542 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700543 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700544 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700545else
546 "./${build}" >"$build_output" 2>&1
547 build_exit="$?"
548 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800549 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700550 "./${run}" $run_args "$@" >"$output" 2>&1
551 else
552 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700553 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
554 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700555 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700556 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700557 max_name_length=$(getconf NAME_MAX ${tmp_dir})
558 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
559 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700560 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700561 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700562 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700563 if [ "$?" = "0" ]; then
564 # output == expected
565 good="yes"
566 echo "${test_dir}: succeeded!" 1>&2
567 fi
568fi
569
jeffhao5d1ac922011-09-29 17:41:15 -0700570(
Alex Lightbfac14a2014-07-30 09:41:21 -0700571 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700572 echo "${test_dir}: FAILED!"
573 echo ' '
574 echo '#################### info'
575 cat "${td_info}" | sed 's/^/# /g'
576 echo '#################### diffs'
Ian Rogers997f0f92014-06-21 22:58:05 -0700577 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 500
jeffhao5d1ac922011-09-29 17:41:15 -0700578 echo '####################'
579 echo ' '
580 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700581
582) 1>&2
583
584# Clean up test files.
585if [ "$always_clean" = "yes" -o "$good" = "yes" ]; then
586 cd "$oldwd"
587 rm -rf "$tmp_dir"
588 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
589 adb shell rm -rf $DEX_LOCATION
590 fi
591 if [ "$good" = "yes" ]; then
592 exit 0
593 fi
594fi
595
596
597(
598 if [ "$always_clean" = "yes" ]; then
599 echo "${TEST_NAME} files deleted from host "
600 if [ "$target_mode" == "yes" ]; then
601 echo "and from target"
602 fi
603 else
604 echo "${TEST_NAME} files left in ${tmp_dir} on host"
605 if [ "$target_mode" == "yes" ]; then
606 echo "and in ${DEX_LOCATION} on target"
607 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -0700608 fi
609
jeffhao5d1ac922011-09-29 17:41:15 -0700610) 1>&2
611
612exit 1